class Layout:

    def __init__(self):
        self._managed_widgets = []

    def add(self, widget, *args, **kwargs):
        """Add widget to layout.

        Additional arguments may be used by specialized layouts as hints.

        """
        self._managed_widgets.append(widget)

    def update(self, w, h):
        """Rearrange managed widgets in given space.

        `w`, `h` is available horizontal and vertical space,
        or width and height of parent container of managed widgets.

        """
        pass

